
version = '0.1.0'
def json_search(json_data, key: str):
    path = []
    if isinstance(json_data, dict):
        for k in json_data.keys():
            if k == key:
                path.append([k])
            child = json_data[k]
            if key not in str(child):
                continue
            for subpath in json_search(child, key):
                path.append([k] + subpath)

    if isinstance(json_data, list):
        for i, child in enumerate(json_data):
            if key not in str(child):
                continue
            for subpath in json_search(child, key):
                path.append([i] + subpath)


    return path

if __name__ == '__main__':
    test_data = {
        'a':{
            'b':{
                'c':'123',
                'd':{
                    'c':123,
                },
                'e':[{'a':1}, {'b':2}, {'c':3}],
                'f':[
                    {'a':
                        {'c':1}
                    },
                    {'b':
                        {'c':2}
                    }
                ]
            }
        }
    }
    for ret in json_search(test_data, 'c'):
        print(ret)